if (yws_isUndefined(Date.prototype.DateDiff)) {
	include("DateExpFunction.js");
}

function Padding(padding) {
	var v = 0;
	if (!yws_isUndefined(padding))
		v = padding;
	this.left = v;
	this.top = v;
	this.right = v;
	this.bottom = v;
}

function Calendar(frame) {
	if (yws_isUndefined(frame))
		return null;
	var back = frame;
	var header = null;
	var title = null;
	var content = null;
	this.padding = new Padding();
	this.sunColor = '#FF0000';
	this.satColor = '#008000';
	this.dayColor = '#000000';
	this.todayColor = '#0000FF';
	this.forecastOvulateColor = '#FF00FF';
	this.useShadow = true;
	this.bgImage = null;
	this.bgImageOpacity = null;
	this.bgOpacity = null;
	this.headerHeight = 20;
	this.headerFont = 'Arial';
	this.headerSize = 20;
	this.headerStyle = 'bold';
	this.headerColor = '#000000';
	this.headerAlign = 'right';
	this.weekTitle = null;
	this.weekFont = 'Arial';
	this.weekSize = 14;
	this.weekStyle = 'bold';
	this.font = 'Arial';
	this.size = 14;
	this.style = 'bold';
	this.width = null;
	this.height = null;
	this.selectedDate = new Date();
	this.periodXmlDoc = null;
	this.periodCycle = 0;
	this.goPrevMonth = function() {
		this.selectedDate = this.selectedDate.DateAdd('m', -1);
		this.renderControl();
	}
	this.goNextMonth = function() {
		this.selectedDate = this.selectedDate.DateAdd('m', 1);
		this.renderControl();
	}
	this.goTodayMonth = function() {
		this.selectedDate = new Date();
		this.renderControl();
	}
	this.renderControl = function() {
		if (back == null)
			return;
		if (this.width == null)
			var w = back.width;
		else
			var w = this.width;
		w -= (this.padding.left + this.padding.right);
		if (this.height == null)
			var h = back.height;
		else
			var h = this.height;
		h -= (this.padding.top + this.padding.bottom);
		var t = this.padding.top;
		var l = this.padding.left;
		if (this.bgImage != null) {
			var bg = new Image();
			bg.src = this.bgImage;
			bg.setPositionAndSize(0, 0, back.width, back.height);
			back.addSubview(bg);
		}
		if (header != null)
			header.removeFromSuperview();
		header = new Frame();
		header.setPosition(0, 0, w, this.headerHeight);
		back.addSubview(header);
		var headerText = new Text();
		with (headerText) {
			font = this.headerFont;
			size = this.headerSize;
			style = this.headerStyle;
			color = this.headerColor;
			align = this.headerAlign;
			data = this.selectedDate.toFormat('yyyy/mm');
			vOffset = t + height - 8;
			shadow = getShadow('#FFFFFF');
			switch (this.headerAlign) {
				case 'right':
					hOffset = l + w - width;
					break;
				case 'center':
					hOffset = l + (w - width) / 2;
					break;
				default:
					hOffset = l;
					break;
			}
		}
		header.addSubview(headerText);
		btnPrevMonth.Top = t;
		btnPrevMonth.Left = l;
		btnPrevMonth = createButtonControl(header, btnPrevMonth);
		btnThisMonth.Top = t;
		btnThisMonth.Left = btnPrevMonth.Left + btnPrevMonth.Width + 1;
		btnThisMonth = createButtonControl(header, btnThisMonth);
		btnNextMonth.Top = t;
		btnNextMonth.Left = btnThisMonth.Left + btnThisMonth.Width + 1;
		btnNextMonth = createButtonControl(header, btnNextMonth);

		if (title != null)
			title.removeFromSuperview();
		title = getWeekTitle(l, t, w, 20, header, this.weekTitle, this.sunColor, this.satColor, this.dayColor, this.weekFont, this.weekSize, this.weekStyle);
		back.addSubview(title);
		if (content != null)
			content.removeFromSuperview();
		content = renderMonth(l, (title.vOffset + title.height), w, h - (title.vOffset + title.height), 
								this.selectedDate, this.sunColor, this.satColor, this.dayColor, this.todayColor, this.forecastOvulateColor, 
								this.periodXmlDoc, this.periodCycle, this.font, this.size, this.style);
		back.addSubview(content);
		updateNow();

		function getWeekTitle(l, t, w, h, header, weeks, c1, c2, c3, hFont, hSize, hStyle) {
			var f = new Frame();
			f.setPositionAndSize(l, header.vOffset + header.height, w, h);
			var cellWidth = Math.floor(w / 7);
			var s = getShadow('#FFFFFF');
			for (var i = 0; i < 7; i++) {
				var txt = new Text();
				with (txt) {
					data = weeks[i];
					setPositionAndSize(i * cellWidth + cellWidth / 2, txt.height - 8, cellWidth, txt.height);
					hAlign = 'center';
					font = hFont;
					size = hSize;
					style = hStyle;
					shadow = s;
					switch (i) {
						case 0:
							color = c1;
							break;
						case 6:
							color = c2;
							break;
						default:
							color = c3;
							break;
					}
				}
				f.addSubview(txt);
			}
			return f;
		}

		function renderMonth(l, t, w, h, date, c1, c2, c3, c4, c5, periodData, cycle, cFont, cSize, cStyle) {
			var firstDate = date.DateAdd('d', -date.getDate() + 1);
			var lastDate = firstDate.DateAdd('m', 1);
			var monthDays = firstDate.DateDiff('d', lastDate);
			var totalDays = monthDays + firstDate.getDay() + (7 - lastDate.getDay());
			var weeks = totalDays / 7;
			var s = getShadow();
			var frame = new Frame();
			frame.setPositionAndSize(l, t, w, h);
			var cellWidth = Math.floor(w / 7);
			var cellHeight = Math.floor(h / 6);
			var periodDate = null;
			var periodLength = 0;
			var ovulateDate = new Array();
			var prePeriod = null;
			if (date.DateDiff('m', new Date()) <= 0)
				prePeriod = getPredictPeriodDate(periodData, cycle);
			if (cycle != 0) {
				for (var i = 0; i < js_OvulateDays.length; i++) {
					ovulateDate[ovulateDate.length] = js_OvulateDays[i].PrevOvul;
					ovulateDate[ovulateDate.length] = js_OvulateDays[i].NextOvul;
					/*
					if (date.DateDiff('m', js_OvulateDays[i].PrevOvul) == -1 || date.DateDiff('m', js_OvulateDays[i].PrevOvul) == 0)
						ovulateDate[ovulateDate.length] = js_OvulateDays[i].PrevOvul;
					else if (date.DateDiff('m', js_OvulateDays[i].NextOvul) == 0 || date.DateDiff('m', js_OvulateDays[i].NextOvul) == 1)
						ovulateDate[ovulateDate.length] = js_OvulateDays[i].NextOvul;
					*/
				}
			}
			/*
			for (var i = 0; i < ovulateDate.length; i++) {
				print(ovulateDate[i].toFormat('yyyy/mm/dd'));
			}
			*/
			if (periodData != null)
				var root = periodData.documentElement;
			else
				var root = null;
			for (var i = 0; i < weeks; i++) {
				for (var j = 0; j < 7; j++) {
					var idx = i * 7 + j - firstDate.getDay();
					if (idx < 0 || idx >= monthDays)
						continue;

					var cell = new Text();
					with (cell) {
						data = idx + 1;
						if (data.length == 1)
							data = ' ' + data;
						var cellDate = firstDate.DateAdd('d', idx);
						setPositionAndSize(j * cellWidth + cellWidth / 2, (i + 1) * cellHeight - 8, cellWidth, cellHeight);
						hAlign = 'center';
						font = cFont;
						size = cSize;
						style = cStyle;
						switch (j) {
							case 0:
								color = c1;
								break;
							case 6:
								color = c2;
								break;
							default:
								if (cellDate.DateDiff('d', new Date()) == 0)
									color = c4;
								else
									color = c3;
								break;
						}
					}
					frame.addSubview(cell);
					with (cell) {
						if (cellDate.DateDiff('d', new Date()) == 0) {
							tooltip = jscl_Tooltips[3];
						}
						var addImg = false;
						if (root != null) {
							var nodes = root.evaluate('Table[Date="' + cellDate.toFormatString('ed', true) + '"]');
							if (nodes.length != 0) {
								periodDate = cellDate;
								periodLength = parseInt(nodes.item(0).evaluate('Length').item(0).firstChild.data);
								addImg = true;
							} else if (periodDate != null && periodLength != 0) {
								if (periodDate.DateDiff('d', cellDate) < periodLength)
									addImg = true;
							}
						}
						if (addImg) {
							tooltip = jscl_Tooltips[5];
							var iB = new Image();
							iB.src = 'Resources/Images/Icons/Blood.png';
							iB.setPosition(j * cellWidth + 32, i * cellHeight + 7);
							frame.addSubview(iB);
						}
						for (var k = 0; k < ovulateDate.length; k++) {
							if (cellDate.DateDiff('d', ovulateDate[k]) <= 2 && cellDate.DateDiff('d', ovulateDate[k]) >= -2) {
								// print(cellDate.toFormat('yyyy/mm/dd') + ' / ' + ovulateDate[k].toFormat('yyyy/mm/dd'));
								color = c5;
								tooltip = jscl_Tooltips[8];
							}
							if (cellDate.DateDiff('d', ovulateDate[k]) == 0) {
								tooltip = jscl_Tooltips[6];
								var iB = new Image();
								iB.src = 'Resources/Images/Icons/Ovulate.png';
								iB.setPosition(j * cellWidth + 32, i * cellHeight + 7);
								frame.addSubview(iB);
								break;
							}
						}
						if (prePeriod != null && cellDate.DateDiff('d', prePeriod) == 0) {
							tooltip = jscl_Tooltips[7];
							var iB = new Image();
							iB.src = 'Resources/Images/Icons/FutureBlood.png';
							iB.setPosition(j * cellWidth + 32, i * cellHeight + 7);
							frame.addSubview(iB);
						}
						tooltip += cellDate.toFormatString('ed', true);
					}
				}
			}
			return frame;
		}
	}
}
