if (yws_isUndefined(Date.prototype.DateDiff)) {
	include("DateExpFunction.js");
}

var com_SelectedDate = null;
var com_frmCalendarBody = null;
var com_SundayColor = '#FF0000';
var com_SaturdayColor = '#00FFFF';
var com_WorkdayColor = '#FFFFFF';
var com_ShadowColor = '#000000';
var com_TodayColor = '#FF8000';
var com_SelectedDateColor = '#FF00FF';
var com_CallBack = null;
var com_WeekDay = jscl_WeekDay;
var com_CellHeight = 12;

function com_StartSelect(v) {
	if (v == null || yws_isUndefined(v))
		com_SelectedDate = new Date();
	else {
		if (typeof(v) == 'string')
			com_SelectedDate = new Date(v);
		else
			com_SelectedDate = v;
	}
	//print(com_SelectedDate.toFormatString('ed', true));
	com_frmHeader.addSubview(com_GetWeekTitles());
	com_DrawCalendar(com_SelectedDate.getFullYear(), com_SelectedDate.getMonth() + 1);
}

function com_GoPrevMonth() {
	com_SelectedDate = com_SelectedDate.DateAdd('m', -1);
	com_DrawCalendar(com_SelectedDate.getFullYear(), com_SelectedDate.getMonth() + 1);
}

function com_GoToday() {
	com_SelectedDate = new Date();
	com_DrawCalendar(com_SelectedDate.getFullYear(), com_SelectedDate.getMonth() + 1);
}

function com_GoNextMonth() {
	com_SelectedDate = com_SelectedDate.DateAdd('m', 1);
	com_DrawCalendar(com_SelectedDate.getFullYear(), com_SelectedDate.getMonth() + 1);
}

function com_DrawCalendar(year, month) {
	if (com_frmCalendarBody != null)
		com_frmCalendarBody.removeFromSuperview();
	com_txtMonth.data = year + '/' + month;
	com_frmCalendarBody = com_GetCalendar(year, month);
	com_CalendarBody.addSubview(com_frmCalendarBody);
}

function com_GetWeekTitles() {
	var frame = new Frame();
	with (frame) {
		hOffset = 10;
		vOffset = 35;
		width = com_frmHeader.width;
		height = 50;
	}
	var width = Math.floor((frame.width - 20) / 7);
	var s = com_GetShadow();
	for (var i = 0; i < 7; i++) {
		var txt = new Text();
		with (txt) {
			data = com_WeekDay[i];
			vOffset = 15;
			hOffset = width * (i + 1) - 2;
			width = width;
			height = 12;
			font = 'Arial';
			size = 12;
			truncation = 'none';
			hAlign = 'right';
			shadow = s;
			switch (i) {
				case 0:
					color = com_SundayColor;
					break;
				case 6:
					color = com_SaturdayColor;
					break;
				default:
					color = com_WorkdayColor;
					break;
			}
		}
		frame.addSubview(txt);
	}
	return frame;
}

function com_GetCalendar(year, month) {
	var firstDate = new Date(year, month - 1, 1);
	var lastDate = new Date(year, month, 1);
	var monthDays = firstDate.DateDiff('d', lastDate);
	var totalDays = monthDays + firstDate.getDay() + (7 - lastDate.getDay());
	var weeks = totalDays / 7;
	var s = com_GetShadow();
	var frame = new Frame();
	frame.hOffset = 0;
	frame.vOffset = 10;
	frame.width = com_CalendarBody.width;
	if (weeks == 5) {
		winCalendar.height = 150;
		com_imgCalendar.height = 150;
		com_CalendarBody.height = 100;
	} else {
		winCalendar.height = 175;
		com_imgCalendar.height = 175;
		com_CalendarBody.height = 125;
	}
	frame.height = com_CalendarBody.height;
	var cellWidth = Math.floor((frame.width - 20) / 7);
	for (var i = 0; i < weeks; i++) {
		for (var j = 0; j < 7; j++) {
			var idx = i * 7 + j - firstDate.getDay();
			if (idx < 0 || idx >= monthDays)
				continue;

			var cell = new Text();
			with (cell) {
				data = idx + 1;
				if (data.length == 1)
					data = ' ' + data;
				//width = cellWidth - 15;
				height = com_CellHeight;
				hOffset = (j + 1) * cellWidth + 8;
				vOffset = i * (height + 7) + 8;
				font = 'Arial';
				size = 10;
				shadow = s;
				hAlign = 'right';
				var cellDate = new Date(year, month - 1, idx + 1);
				switch (j) {
					case 0:
						color = com_SundayColor;
						break;
					case 6:
						color = com_SaturdayColor;
						break;
					default:
						color = com_WorkdayColor;
						break;
				}
				if (cellDate.DateDiff('d', new Date()) == 0)
					com_imgToday.setPosition(hOffset - width - 1, vOffset + 1);
				onMouseEnter = 'com_CellMouseEnter(' + idx + ');';
				onMouseDown = 'com_CellMouseDown(' + idx + ');';
				onMultiClick = 'com_CellMultiClick(' + idx + ');';
				if (cellDate.DateDiff('d', com_SelectedDate) == 0)
					com_imgSelected.setPosition(hOffset - width - 1, vOffset + 1);
			}
			frame.addSubview(cell);
		}
	}
	if (cellDate.DateDiff('m', new Date()) == 0)
		com_imgToday.visible = true;
	else
		com_imgToday.visible = false;
	if (cellDate.DateDiff('m', com_SelectedDate) == 0)
		com_imgSelected.visible = true;
	else
		com_imgSelected.visible = false;
	com_imgFocus.visible = false;
	return frame;
}

function com_CellMouseEnter(idx) {
	var cell = com_frmCalendarBody.subviews[idx];
	com_imgFocus.setPosition(cell.hOffset - cell.width - 1, cell.vOffset + 1);
	com_imgFocus.visible = true;
}

function com_CellMouseDown(idx) {
	var cell = com_frmCalendarBody.subviews[idx];
	com_imgSelected.setPosition(cell.hOffset - cell.width - 1, cell.vOffset + 1);
	com_imgSelected.visible = true;
}

function com_CellMultiClick(idx) {
	if (system.event.clickCount < 2)
		return;
	com_SelectedDate = new Date(com_SelectedDate.getFullYear(), com_SelectedDate.getMonth(), idx + 1);
	var cell = com_frmCalendarBody.subviews[idx];
	com_imgSelected.setPosition(cell.hOffset - cell.width - 1, cell.vOffset + 1);
	com_imgSelected.visible = true;
	eval(com_CallBack());
}

function com_GetShadow(color) {
	var s = new Shadow();
	s.vOffset = 1;
	s.hOffset = 1;
	if (!yws_isUndefined(color) && color != null) 
		s.color = color;
	else
		s.color = com_ShadowColor;
	return s;
}

function com_onLoseFocus() {
	winCalendar.visible = false;
}

function com_TodayEnter() {
	com_btnToday.src = 'Resources/Images/Calendar/TodayEnter.png';
}
function com_TodayExit() {
	com_btnToday.src = 'Resources/Images/Calendar/TodayNormal.png';
}
function com_TodayDown() {
	com_btnToday.src = 'Resources/Images/Calendar/TodayPress.png';
}
function com_TodayUp() {
	com_btnToday.src = 'Resources/Images/Calendar/TodayEnter.png';
	com_GoToday();
}

function com_RightEnter() {
	com_btnNextMonth.src = 'Resources/Images/Calendar/RightEnter.png';
}
function com_RightExit() {
	com_btnNextMonth.src = 'Resources/Images/Calendar/RightNormal.png';
}
function com_RightDown() {
	com_btnNextMonth.src = 'Resources/Images/Calendar/RightPress.png';
}
function com_RightUp() {
	com_btnNextMonth.src = 'Resources/Images/Calendar/RightEnter.png';
	com_GoNextMonth();
}

function com_LeftEnter() {
	com_btnPrevMonth.src = 'Resources/Images/Calendar/LeftEnter.png';
}
function com_LeftExit() {
	com_btnPrevMonth.src = 'Resources/Images/Calendar/LeftNormal.png';
}
function com_LeftDown() {
	com_btnPrevMonth.src = 'Resources/Images/Calendar/LeftPress.png';
}
function com_LeftUp() {
	com_btnPrevMonth.src = 'Resources/Images/Calendar/LeftEnter.png';
	com_GoPrevMonth();
}
