include('Variable.js');
include('CustomYWSMethods.js');
include('DateExpFunction.js');
var langFile = 'Resources\\Languages\\' + widget.locale + '.js';
if (filesystem.itemExists(langFile))
	include(langFile);
else
	include('Resources\\Languages\\en.js');

include('Const.js');
include('CommonCalendar.js');
include('StandardControl.js');
include('Grid.js');
include('Calendar.js');
include('UIAction.js');
include('Events.js');
include('Utils.js');
include('RenderUI.js');

var miAppDesc = new MenuItem();
miAppDesc = new MenuItem();
miAppDesc.title = jscl_MenuItems[0];
miAppDesc.onSelect = 'showMemoWindow();';
contextMenu.push(miAppDesc);
var miAppVer = new MenuItem();
miAppVer = new MenuItem();
miAppVer.title = jscl_MenuItems[1];
miAppVer.onSelect = 'showVerWindow();';
contextMenu.push(miAppVer);
winBase.contextMenuItems = contextMenu;
//winBase.onContextMenu = "mainWindow_onContextMenu()";

initWidget();

function initWidget() {
	setLanguage();
	if (preferences.UsePassword.value == 1)
		openLogonWindow();
	else
		startup();
}

function startup() {
	preferences.UsePassword.hidden = false;
	preferences.NewPassword.hidden = false;
	preferences.ConfirmPassword.hidden = false;
	resetControls();
	renderWindow();
	switchTab(0);
	loadRecord();
	recountPervPeriodRange(js_PeriodData);
	renderInterface();
	winBase.visible = true;
	winBase.focus();
}
/*
function loadCOM() {
	try {
		js_WidgetDLL = COM.createObject('WidgetDLL.PeriodTool');
	} catch (e) {}
	if (js_WidgetDLL != null)
		js_IsComReady = true;
}

function clearGarbage() {
	js_WidgetDLL.ClearGarbage();
}
*/

function loadRecord() {
	if (preferences.PeriodRecord.value != null && preferences.PeriodRecord.value != '') {
		try {
			js_PeriodData = XMLDOM.parse(preferences.PeriodRecord.value);
		} catch (e) {
			alert(jscl_ErrorMessages[2] + '\n' + e);
		}
	} else {
		js_PeriodData = XMLDOM.createDocument(); 
		var root = js_PeriodData.createElement('NewDataSet'); 
		js_PeriodData.appendChild(root);
	}
	js_PeriodData = sortXml(js_PeriodData, 'Table', 'Date', true);
	recountPervPeriodRange(js_PeriodData);
	js_AveCycle = reckonAverageCycle(js_PeriodData);
	js_OvulateDays = getOvulateDays(js_PeriodData, js_AveCycle);

	if (preferences.TemperRecord.value != null && preferences.TemperRecord.value != '') {
		try {
			js_TemperData = XMLDOM.parse(preferences.TemperRecord.value);
		} catch (e) {
			alert(jscl_ErrorMessages[2] + '\n' + e);
		}
	} else {
		js_TemperData = XMLDOM.createDocument(); 
		var root = js_TemperData.createElement('NewDataSet'); 
		js_TemperData.appendChild(root);
	}
	js_TemperData = sortXml(js_TemperData, 'Table', 'Date', true);
}

function saveRecord() {
	preferences.PeriodRecord.value = js_PeriodData.toXML();
	preferences.TemperRecord.value = js_TemperData.toXML();
}


function AppendPeriod() {
	var root = js_PeriodData.documentElement;
	var row = js_PeriodData.createElement('Table');
	var date = js_PeriodData.createElement('Date');
	date.appendChild(js_PeriodData.createTextNode(dccPeriod.Date));
	row.appendChild(date);
	var length = js_PeriodData.createElement('Length');
	length.appendChild(js_PeriodData.createTextNode(nudPeriod.Value));
	row.appendChild(length);
	c = 'N/A';
	var cycle = js_PeriodData.createElement('Cycle');
	cycle.appendChild(js_PeriodData.createTextNode(c));
	row.appendChild(cycle);
	root.appendChild(row);
	js_PeriodData = sortXml(js_PeriodData, 'Table', 'Date', true);
}

function AppendTemper() {
	var root = js_TemperData.documentElement;
	var row = js_TemperData.createElement('Table');
	var date = js_TemperData.createElement('Date');
	date.appendChild(js_TemperData.createTextNode(dccTemper.Date));
	row.appendChild(date);
	var temper = js_TemperData.createElement('Temperature');
	temper.appendChild(js_TemperData.createTextNode(nudTemper.Value));
	//row.appendChild(temper);
	//var unit = js_TemperData.createAttribute('Unit');
	//unit.value = preferences.TemperatureUnit.value;
	//unit.value = 'C';
	//temper.appendChild(unit);
	row.appendChild(temper);
	root.appendChild(row);
	js_TemperData = sortXml(js_TemperData, 'Table', 'Date', true);
}

function checkRecordExists(xmlDoc, date) {
	var root = xmlDoc.documentElement;
	var rows = root.evaluate('Table/Date');
	var d1 = new Date(date);
	for (var i = 0; i < rows.length; i++) {
		var d2 = new Date(rows.item(i).firstChild.data);
		if (d1.DateDiff('d', d2) == 0)
			return true;
	}
	return false;
}

function checkPeriodRules() {
	if (checkRecordExists(js_PeriodData, dccPeriod.Date)) {
		alert(jscl_ErrorMessages[3]);
		return false;
	}
	if (!checkPrevPeriodLengthCorrect()) {
		alert(jscl_ErrorMessages[4]);
		return false;
	}
	if (checkIsFutureDay(dccPeriod.Date)) {
		alert(jscl_ErrorMessages[5]);
		return false;
	}
	return true;
}

function checkPrevPeriodLengthCorrect() {
	var root = js_PeriodData.documentElement;
	var rows = root.evaluate('Table/Date');
	var d1 = new Date(dccPeriod.Date);
	var ld1 = null;
	var ld2 = null;
	var v1 = 0;
	var v2 = 0;
	if (rows.length == 0)
		return true;
	for (var i = 0; i < rows.length; i++) {
		var d2 = new Date(rows.item(i).firstChild.data);
		var len1 = d2.DateDiff('d', d1);
		var len2 = d1.DateDiff('d', d2);
		print(d1.toFormat('yyyy/mm/dd') + ' / ' + d2.toFormat('yyyy/mm/dd') + ' / ' + len1 + ' / ' + len2);
		if (len1 > 0) {
			if (v1 > len1)
				v1 = len1;
			else {
				ld1 = d2;
				break;
			}
		}
		if (len2 > 0) {
			if (v2 > len2)
				v2 = len2;
			else {
				ld2 = d2;
				//break;
			}
		}
	}
	print(ld1 + ' / ' + ld2);
	if (ld1 == null) {
		if (d1.DateDiff('d', ld2) < 23 || d1.DateDiff('d', ld2) > 60)
			return false;
		else
			return true;
	} else {
		if (ld1.DateDiff('d', d1) < 23 || ld1.DateDiff('d', d1) > 60) {
			if (d1.DateDiff('d', ld2) < 23 || d1.DateDiff('d', ld2) > 60)
				return false;
			else
				return true;
		} else
			return true;
	}
}

function checkTemperRules() {
	if (checkRecordExists(js_TemperData, dccTemper.Date)) {
		alert(jscl_ErrorMessages[3]);
		return false;
	}
	if (checkIsFutureDay(dccPeriod.Date)) {
		alert(jscl_ErrorMessages[5]);
		return false;
	}
	return true;
}
