function renderWindow() {
	renderTabs();
}

function renderTabs() {
	for (var i = 0; i < 3; i++) {
		createTabs(i);

		var frm = new Frame();
		frm.setPositionAndSize(96, 30, 315, 215);
		frm.zOrder = 9;
		frm.visible = false;

		if (i <= 1) {
			createGridArea(frm, i);
			createGridControlArea(frm, i);
		}
		tabContent[tabContent.length] = frm;
		frmBase.addSubview(frm);
	}
	updateNow();
}

function createTabs(i) {
	var events = { OnMouseEnter:'tab_onMouseEnter(' + i + ');', 
				   OnMouseExit:'tab_onMouseExit(' + i + ');', 
				   OnMouseDown:'tab_onMouseDown(' + i + ');', 
				   OnMouseUp:'tab_onMouseUp(' + i + ');' };
	var obj = createButtonInterface(frmBase, 17, (i + 1) * 23 + 1, 72, 23, jscl_TabTitle[i], jscl_TabTitleTooltip[i], events);
	obj.Button.src = 'Resources/Images/Tabs/Tab.png';
	obj.Button.zOrder = 0;
	obj.Label.zOrder = 20;
	tabImages[i] = obj.Button;
}

function createGridArea(frm, i) {
	var gf = new Frame();
	gf.setPositionAndSize(0, 0, 315, 190);
	js_GridForm[js_GridForm.length] = gf;
	frm.addSubview(gf);
}

function createGridControlArea(frm, i) {
	var ca = new Frame();
	ca.setPositionAndSize(0, js_GridForm[i].vOffset + js_GridForm[i].height, 315, 215 - js_GridForm[i].height);
	js_GridCtrl[js_GridCtrl.length] = ca;
	
	if (i == 0) {
		btnAddPeriod = createButtonControl(ca, btnAddPeriod);
		dccPeriod.Top = btnAddPeriod.Top;
		dccPeriod.Left = 4;
		dccPeriod = createDateChooserControl(ca, dccPeriod);
		nudPeriod.Left = dccPeriod.Left + dccPeriod.Width + 1;
		nudPeriod.Top = dccPeriod.Top;
		nudPeriod = createNumericUpDownControl(ca, nudPeriod);
	} else {
		btnAddTemper = createButtonControl(ca, btnAddTemper);
		dccTemper.Top = btnAddTemper.Top;
		dccTemper.Left = 4;
		dccTemper = createDateChooserControl(ca, dccTemper);
		nudTemper.Left = dccTemper.Left + dccTemper.Width + 1;
		nudTemper.Top = dccTemper.Top;
		nudTemper = createNumericUpDownControl(ca, nudTemper);
	}
	frm.addSubview(ca);
}

function closeActionForm(idx) {
	tabContent[idx].visible = true;
	imgShowArea.visible = true;
	enableTabEvents();
}

function ShowCalendar() {
	winCalendar.hOffset = winSetting.hOffset + frmSetting.hOffset + imgDropDownButton.hOffset - 5;
	winCalendar.vOffset = winSetting.vOffset + frmSetting.vOffset  + imgDropDownButton.vOffset + imgDropDownButton.height;
	winCalendar.visible = true;
	com_CallBack = GetDateCallBack;
	com_StartSelect(set_FirstMC);
}
function renderInterface() {
	if (gridPeriod == null) {
		gridPeriod = new Grid();
		with (gridPeriod) {
			name = 'gridPeriod';
			top = 0;
			left = 0;
			width = tabContent[0].width;
			height = tabContent[0].height;
			displayMaxRows = preferences.RecordMaxCount.value;
			cellBgImageSrc = js_TextBoxBackgroundImage_S;
		}
	}
	renderGrid(gridPeriod, js_PeriodData, js_PeriodGridColumns, js_GridForm[0]);

	if (gridTemper == null) {
		gridTemper = new Grid();
		with (gridTemper) {
			name = 'gridTemper';
			top = 0;
			left = 0;
			width = tabContent[1].width;
			height = tabContent[1].height;
			displayMaxRows = preferences.RecordMaxCount.value;
			cellBgImageSrc = js_TextBoxBackgroundImage_S;
		}
	}
	renderGrid(gridTemper, js_TemperData, js_TemperGridColumns, js_GridForm[1]);
	
	objCalendar = new Calendar(tabContent[2]);
	with (objCalendar) {
		padding = new Padding(5);
		weekTitle = jscl_WeekDay;
		periodXmlDoc = js_PeriodData;
		periodCycle = js_AveCycle;
		renderControl();
	}
}

function renderGrid(grid, xmlDoc, cols, frame) {
	grid.clear();
	grid.dataBind(xmlDoc);
	for (var i = 0; i < grid.columns.length; i++)
		grid.columns[i].visible = false;
	for (var i = 0; i < cols.length; i++) {
		var json = cols[i];
		var col = grid.getColumn(json.Key);
		if (col == null)
			col = grid.addColumn(json.Key, json.Title);
		col.title = json.Title;
		col.width = json.Width;
		col.tooltip = json.Tooltip;
		col.font = json.Font;
		col.size = json.Size;
		col.color = json.Color;
		col.bgImageSrc = json.BgImageSrc;
		col.cellStyle.color = json.CellStyle.Color;
		col.cellStyle.font = json.CellStyle.Font;
		col.cellStyle.size = json.CellStyle.Size;
		col.cellStyle.style = json.CellStyle.Style;
		col.cellStyle.align = json.CellStyle.Align;
		col.cellStyle.bgColor = json.CellStyle.BgColor;
		col.cellStyle.bgOpacity = json.CellStyle.BgOpacity;
		col.cellStyle.bgImageOpacity = json.CellStyle.BgImageOpacity;
		col.onMouseEnter = json.ColumnEvent.MouseEnter;
		col.onMouseExit = json.ColumnEvent.MouseExit;
		col.onMouseDown = json.ColumnEvent.MouseDown;
		col.onMouseUp = json.ColumnEvent.MouseUp;
		col.visible = true;
		if (json.CellType == GridCellType.Image) {
			var rows = grid.rows;
			for (var j = 0; j < rows.length; j++) {
				var cell = rows[j].getCellByColumnKey(json.Key);
				cell.type = GridCellType.Image;
				if (cell == null)
					continue;
				if (json.ImageSrc != null)
					cell.imageSrc = json.ImageSrc;
				if (json.ImageWidth != null)
					cell.imageWidth = json.ImageWidth;
				if (json.ImageHeight != null)
					cell.imageHeight = json.ImageHeight;
				if (json.CellEvent.MouseEnter != null)
					cell.onMouseEnter = json.CellEvent.MouseEnter;
				if (json.CellEvent.MouseExit != null)
					cell.onMouseExit = json.CellEvent.MouseExit;
				if (json.CellEvent.MouseDown != null)
					cell.onMouseDown = json.CellEvent.MouseDown;
				if (json.CellEvent.MouseUp != null)
					cell.onMouseUp = json.CellEvent.MouseUp;
			}
		}
	}
	grid.renderControl(frame);
}

function openLogonWindow() {
	preferences.UsePassword.hidden = true;
	preferences.NewPassword.hidden = true;
	preferences.ConfirmPassword.hidden = true;
	createLabelInterface(frmLogon, 120, 20, 250, null, jscl_LogonWindowTitle, '#FFFFFF', 'center', 'Arial', '14', 'bold');
	createLabelInterface(frmLogon, 100, 55, null, null, jscl_Labels[0], '#FFFFFF', 'right', 'Arial', '14', 'bold');
	txtPassword = createTextAreaControl(frmLogon, js_PasswordTextBox);
	btnCheckPWD = createButtonControl(frmLogon, btnCheckPWD);
	btnCancelLogon = createButtonControl(frmLogon, btnCancelLogon);
	winLogon.visible = true;
	txtPassword.Object.TextArea.focus();
	return false;
}
