function getShadow(color) {
	var s = new Shadow();
	s.vOffset = 1;
	s.hOffset = 1;
	if (!yws_isUndefined(color) && color != null) 
		s.color = color;
	else
		s.color = '#000000';
	return s;
}

function getRealPosition(obj) {
	var left = obj.window.hOffset;
	var top = obj.window.vOffset;
	var sv = obj.superview;
	do {
		left += sv.hOffset;
		top += sv.vOffset;
		sv = sv.superview;
	} while (sv != obj.window.root);

	return { Left:left, Top:top };
}

function createDropDownInterface(frame, x, y, w, value, events, editable, color, font, size, style, tip) {
	var box = new Image();
	box.src = js_TextBoxBackgroundImage_S;
	box.setPositionAndSize(x, y, w, 20);
	if (!yws_isUndefined(tip) && tip != null) 
		box.tooltip = tip;
	frame.addSubview(box);

	var ddl = new Image();
	ddl.src = js_DDLButtonImage;
	ddl.setPositionAndSize(box.hOffset + box.width - 18, y + 2, 16, 16);
	ddl.onMouseEnter = function() {
		this.src = js_DDLButtonEnterImage;
	};
	ddl.onMouseExit = function() {
		this.src = js_DDLButtonExitImage;
	};
	if (!yws_isUndefined(events) && events != null) {
		ddl.onMouseDown = events.OnMouseDown;
		ddl.onMouseUp = events.OnMouseUp;
	} else {
		ddl.onMouseDown = function() {
			this.src = js_DDLButtonDownImage;
		};
		ddl.onMouseUp = function() {
			this.src = js_DDLButtonUpImage;
		};
	}
	if (!yws_isUndefined(tip) && tip != null) 
		ddl.tooltip = tip;
	frame.addSubview(ddl);
	if (yws_isUndefined(value) || value == null) 
		value = '';
	if (yws_isUndefined(color) || color == null) 
		color = '#000000';
	if (yws_isUndefined(font) || font == null) 
		font = js_DisplayFont;
	if (yws_isUndefined(size) || size == null) 
		size = 12;
	if (yws_isUndefined(style) || style == null) 
		style = 'bold';
	if (yws_isUndefined(editable) || editable == null || !editable) {
		var lab = createLabelInterface(frame, box.hOffset + (box.width - 18) / 2, box.vOffset, null, null, value, color, 'center', font, size, style, tip);
		lab.vOffset += lab.height;
	} else
		var txt = createTextAreaInterface(frame, box.hOffset, y, w, null, value, color, null, font, size, style, tip, 1, null);
	
	return { Box:box, Button:ddl, Label:lab, TextArea:txt };
}

function createDropDownListControl(frame, json) {
	if (yws_isUndefined(winDropDown)) {
		alert('Can not found <window name="winDropDown" /> in .kon');
		return json;
	}
}

function createDateChooserControl(frame, json) {
	// Use winCalendar
	if (yws_isUndefined(winCalendar)) {
		alert('Can not found <window name="winCalendar" /> in .kon');
		return json;
	}
	if (yws_isUndefined(com_StartSelect)) {
		alert('Not include CommonCalendar.js');
		return json;
	}
	json.Object = createDropDownInterface(frame, json.Left, json.Top, json.Width, json.Date, null, 
										  json.Editable, json.Color, json.Font, json.Size, json.Style, json.Tooltip);
	json.Object.Button.onMouseDown = function() {
		this.src = js_DDLButtonDownImage;
		var lt = getRealPosition(this);
		var left = lt.Left + this.hOffset - 5;
		var top = lt.Top + this.vOffset + this.height;
		if (left + winCalendar.width > screen.width)
			left = left - winCalendar.width + json.Object.Button.width * 3;
		winCalendar.hOffset = left;
		if (top + winCalendar.height > screen.height)
			top = top - winCalendar.height + 10;
		winCalendar.vOffset = top;
		com_CallBack = json.CallBack;
		com_StartSelect(json.Date);
		winCalendar.visible = true;
		winCalendar.focus();
	};
	json.Object.Button.onMouseUp = function() {
		this.src = js_DDLButtonEnterImage;
	};
	return json;
}

function createButtonInterface(frame, x, y, w, h, title, tip, events, align, font, size, color, style, shadowColor, imgs) {
	var btn = new Image();
	if (!yws_isUndefined(imgs) && imgs != null) 
		btn.src = imgs.Normal;
	else
		btn.src = js_BlackButtonImage;
	btn.setPositionAndSize(x, y, w, h);
	if (!yws_isUndefined(tip) && tip != null) 
		btn.tooltip = tip;
	if (!yws_isUndefined(align) && align != null) 
		btn.hAlign = align;
	if (!yws_isUndefined(events) && events != null) {
		if (typeof(events.OnMouseEnter) != 'undefined' && events.OnMouseEnter != null)
			btn.onMouseEnter = events.OnMouseEnter;
		else
			btn.onMouseEnter = function() {
				if (!yws_isUndefined(imgs) && imgs != null && imgs.Enter != null) 
					this.src = imgs.Enter;
				else
					this.src = js_BlackButtonEnterImage;
			};
		if (typeof(events.OnMouseExit) != 'undefined' && events.OnMouseExit != null)
			btn.onMouseExit = events.OnMouseExit;
		else
			btn.onMouseExit = function() {
				if (!yws_isUndefined(imgs) && imgs != null && imgs.Exit != null) 
					this.src = imgs.Exit;
				else
					this.src = js_BlackButtonExitImage;
			};
		if (typeof(events.OnMouseDown) != 'undefined' && events.OnMouseDown != null)
			btn.onMouseDown = events.OnMouseDown;
		else
			btn.onMouseDown = function() {
				if (!yws_isUndefined(imgs) && imgs != null && imgs.Down != null) 
					this.src = imgs.Down;
				else
					this.src = js_BlackButtonDownImage;
			};
		if (typeof(events.OnMouseUp) != 'undefined' && events.OnMouseUp != null)
			btn.onMouseUp = events.OnMouseUp;
		else
			btn.onMouseUp = function() {
				if (!yws_isUndefined(imgs) && imgs != null && imgs.Up != null) 
					this.src = imgs.Up;
				else
					this.src = js_BlackButtonUpImage;
			};
	} else {
		btn.onMouseEnter = function() {
			if (!yws_isUndefined(imgs) && imgs != null && imgs.Enter != null) 
				this.src = imgs.Enter;
			else
				this.src = js_BlackButtonEnterImage;
		};
		btn.onMouseExit = function() {
			if (!yws_isUndefined(imgs) && imgs != null && imgs.Exit != null) 
				this.src = imgs.Exit;
			else
				this.src = js_BlackButtonExitImage;
		};
		btn.onMouseDown = function() {
			if (!yws_isUndefined(imgs) && imgs != null && imgs.Down != null) 
				this.src = imgs.Down;
			else
				this.src = js_BlackButtonDownImage;
		};
		btn.onMouseUp = function() {
			if (!yws_isUndefined(imgs) && imgs != null && imgs.Up != null) 
				this.src = imgs.Up;
			else
				this.src = js_BlackButtonUpImage;
		};
	}
	frame.addSubview(btn);
	if (title != null) {
		var txt = new Text();
		txt.data = title;
		txt.tooltip = tip;
		txt.hAlign = 'center';
		if (!yws_isUndefined(font) && font != null)
			txt.font = font;
		else
			txt.font = js_DisplayFont;
		if (!yws_isUndefined(size) && size != null)
			txt.size = size;
		else
			txt.size = 12;
		if (!yws_isUndefined(style) && style != null)
			txt.style = style;
		else
			txt.style = 'bold';
		if (!yws_isUndefined(color) && color != null)
			txt.color = color;
		else
			txt.color = '#FFFFFF';
		if (!yws_isUndefined(shadowColor) && shadowColor != null)
			txt.shadow = getShadow(shadowColor);
		else
			txt.shadow = getShadow();
		if (!yws_isUndefined(align) && align != null) {
			if (align == 'right')
				txt.setPosition(x - w / 2, y + txt.height);
			else if (align == 'center')
				txt.setPosition(x, y + txt.height);
			else
				txt.setPosition(x + w / 2, y + txt.height);
		} else
			txt.setPosition(x + w / 2, y + txt.height);
		frame.addSubview(txt);
	} else {
		var txt = null;
	}
	return { Button:btn, Label:txt };
}

function createButtonControl(frame, json) {
	json.Object = createButtonInterface(frame, json.Left, json.Top, json.Width, json.Height, json.Title, json.Tooltip, null, json.Align, json.Font, json.Size, json.Color, json.Style, json.ShadowColor, json.Images);
	if (json.OnClick != null)
		json.Object.Button.onMouseUp = json.OnClick;
	return json;
}

function createLabelInterface(frame, x, y, w, h, title, color, align, font, size, style, tip) {
	var txt = new Text();
	txt.data = title;
	if (!yws_isUndefined(tip) && tip != null) 
		txt.tooltip = tip;
	if (!yws_isUndefined(align) && align != null)
		txt.hAlign = align;
	if (!yws_isUndefined(font) && font != null)
		txt.font = font;
	else
		txt.font = js_DisplayFont;
	if (!yws_isUndefined(size) && size != null)
		txt.size = size;
	else
		txt.size = 10;
	
	if (!yws_isUndefined(style) && style != null)
		txt.style = style;
	if (!yws_isUndefined(color) && color != null)
		txt.color = color;
	else
		txt.color = '#FFFFFF';
	txt.setPosition(x, y);
	if (!yws_isUndefined(w) && w != null)
		txt.width = w;
	if (!yws_isUndefined(h) && h != null && txt.height < h)
		txt.height = h;

	frame.addSubview(txt);
	return txt;
}

function createTextAreaInterface(frame, x, y, w, h, data, color, align, font, size, style, tip, lines, columns) {
	var txt = new TextArea();
	txt.data = data;
	if (!yws_isUndefined(tip) && tip != null) 
		txt.tooltip = tip;
	if (!yws_isUndefined(lines) && lines != null)
		txt.lines = lines;
	if (!yws_isUndefined(columns) && columns != null)
		txt.columns = columns;
	if (!yws_isUndefined(align) && align != null)
		txt.hAlign = align;
	if (!yws_isUndefined(font) && font != null)
		txt.font = font;
	else
		txt.font = js_DisplayFont;
	if (!yws_isUndefined(size) && size != null)
		txt.size = size;
	else
		txt.size = 10;
	
	if (!yws_isUndefined(style) && style != null)
		txt.style = style;
	if (!yws_isUndefined(color) && color != null)
		txt.color = color;
	else
		txt.color = '#000000';
	txt.setPosition(x, y);
	if (!yws_isUndefined(w) && w != null)
		txt.width = w;
	if (!yws_isUndefined(h) && h != null && txt.height < h)
		txt.height = h;

	frame.addSubview(txt);
	return txt;
}

function createCheckBoxControl(frame, chk) {
	var btn = new Image();
	if (chk.Value) {
		btn.src = js_CheckBoxChecked;
		value = true;
	} else {
		btn.src = js_CheckBoxUncheck;
		value = false;
	}
	btn.setPositionAndSize(chk.Left, chk.Top, 14, 14);
	if (chk.Tooltip != '') 
		btn.tooltip = chk.Tooltip;
	btn.onMouseEnter = chk.OnMouseEnter;
	btn.onMouseExit = chk.OnMouseExit;
	btn.onMouseDown = chk.OnMouseDown;
	btn.onMouseUp = chk.OnMouseUp;
	frame.addSubview(btn);

	var txt = createLabelInterface(frame, chk.Left + 18, chk.Top + 10, null, null, chk.Title, chk.Color, 'left', chk.Font, chk.Size, chk.Tooltip);
	txt.onMouseEnter = chk.OnMouseEnter;
	txt.onMouseExit = chk.OnMouseExit;
	txt.onMouseDown = chk.OnMouseDown;
	txt.onMouseUp = chk.OnMouseUp;
	if (chk.ShadowColor != null && chk.ShadowColor != '')
		txt.shadow = getShadow(chk.ShadowColor);
	txt.vOffset = chk.Top + (txt.height - 14) / 2 + 10;
	chk.Object = { Box:btn, Label:txt };
	return chk;
}

function createRadioGroupControl(frame, radios) {
	var top = radios.Top;
	var left = radios.Left;
	for (var i = 0; i < radios.Items.length; i++) {
		var btn = new Image();
		if (radios.SelectedIndex == i || radios.SelectedValue == radios.Items[i].Value)
			btn.src = js_RadioGroupChecked;
		else
			btn.src = js_RadioGroupUncheck;
		btn.setPositionAndSize(left, top, 14, 14);
		if (radios.Items[i].Tooltip != '') 
			btn.tooltip = radios.Items[i].Tooltip;
		btn.onMouseEnter = 'rdo_onMouseEnter(' + i + ');';
		btn.onMouseExit = 'rdo_onMouseExit(' + i + ');';
		btn.onMouseDown = 'rdo_onMouseDown(' + i + ');';
		btn.onMouseUp = 'rdo_onMouseUp(' + i + ');';
		frame.addSubview(btn);
		var txt = createLabelInterface(frame, left + 18, top + 10, null, null, radios.Items[i].Title, radios.Color, 'left', radios.Font, radios.Size, radios.Items[i].Tooltip);
		txt.onMouseEnter = 'rdo_onMouseEnter(' + i + ');';
		txt.onMouseExit = 'rdo_onMouseExit(' + i + ');';
		txt.onMouseDown = 'rdo_onMouseDown(' + i + ');';
		txt.onMouseUp = 'rdo_onMouseUp(' + i + ');';
		if (radios.ShadowColor != null && radios.ShadowColor != '')
			txt.shadow = getShadow(radios.ShadowColor);
		txt.vOffset = top + (txt.height - 14) / 2 + 10;
		if (radios.Vertical) {
			if (txt.height <= 14)
				top += 20;
			else
				top += txt.height + 2;
		} else
			left += txt.width + 30;
		radios.Items[i].Object = { Box:btn, Label:txt };
	}
	return radios;
}

function createTextAreaControl(frame, json) {
	var box = new Image();
	if (json.Lines == 1)
		box.src = js_TextBoxBackgroundImage_S;
	else
		box.src = js_TextBoxBackgroundImage_L;
	box.setPositionAndSize(json.Left, json.Top, json.Width, json.Height);
	if (json.Tooltip != null) 
		box.tooltip = json.Tooltip;
	if (json.Align != null)
		box.hAlign = json.Align;
	frame.addSubview(box);

	var txt = new TextArea();
	if (json.Tooltip != null) 
		txt.tooltip = json.Tooltip;
	if (json.Lines != null && json.Lines != 0)
		txt.lines = json.Lines;
	if (json.Columns != null && json.Columns != 0)
		txt.columns = json.Columns;
	if (json.Editable != null)
		txt.editable = json.Editable;
	if (json.ScrollBar != null)
		txt.scrollbar = json.ScrollBar;
	if (json.Secure != null)
		txt.secure = json.Secure;
	if (json.Font != null)
		txt.font = json.Font;
	if (json.Size != null)
		txt.size = json.Size;
	if (json.Style != null)
		txt.style = json.Style;
	if (json.Color != null)
		txt.color = json.Color;
	if (json.Align != null)
		txt.hAlign = json.Align;
	if (json.ScrollBarColor != null)
		txt.thumbColor = json.ScrollBarColor;
	txt.data = json.Text;
	txt.spellcheck = false;
	txt.setPosition(json.Left, json.Top + 2);
	if (json.width == null) {
		if (txt.scrollbar)
			box.width = txt.width + 2
		else
			box.width = txt.width + 10
	} else {
		txt.width = json.Width - 2;
		box.width = json.Width;
	}
	if (json.height == null)
		box.height = txt.height + 4;
	else {
		txt.height = json.Height;
		box.height = json.Height;
	}
	txt.onKeyPress = json.OnKeyPress;
	frame.addSubview(txt);
	
	json.Object = { Box:box, TextArea:txt };

	return json;
}

function createNumericUpDownControl(frame, json) {
	if (json.Min == null)
		json.Min = 0;
	if (json.Max == null)
		json.Max = 100;
	if (json.Max < json.Min) {
		var v = json.Max;
		json.Max = json.Min;
		json.Min = v;
	}
	var box = new Image();
	box.src = js_TextBoxBackgroundImage_S;
	box.setPositionAndSize(json.Left, json.Top, json.Width, json.Height);
	if (json.Tooltip != null) 
		box.tooltip = json.Tooltip;
	if (json.Align != null)
		box.hAlign = json.hAlign;
	frame.addSubview(box);

	var bup = new Image();
	bup.src = js_NumericUpNormal;
	bup.setPositionAndSize(box.hOffset + box.width - (json.Height - 2), json.Top + 2, json.Height - 4, (json.Height - 4) / 2);
	bup.onMouseEnter = function() {
		this.src = js_NumericUpEnter;
	};
	bup.onMouseExit = function() {
		this.src = js_NumericUpNormal;
	};
	bup.onMouseDown = function() {
		this.src = js_NumericUpDown;
	};
	bup.onMouseUp = function() {
		this.src = js_NumericUpUp;
		if (json.Value < json.Max || json.Loop) {
			json.Value = Math.round((json.Value + json.Interval) * Math.pow(10, 3)) / Math.pow(10, 3);
			if (json.Value > json.Max) {
				if (json.Loop)
					json.Value = json.Min;
				else
					json.Value = json.Max;
			}
		}
		json.Object.TextArea.data = json.Value;
	};
	frame.addSubview(bup);

	var bdn = new Image();
	bdn.src = js_NumericDownNormal;
	bdn.setPositionAndSize(box.hOffset + box.width - (json.Height - 2), json.Top + 2 + (json.Height - 4) / 2, json.Height - 4, (json.Height - 4) / 2);
	bdn.onMouseEnter = function() {
		this.src = js_NumericDownEnter;
	};
	bdn.onMouseExit = function() {
		this.src = js_NumericDownNormal;
	};
	bdn.onMouseDown = function() {
		this.src = js_NumericDownDown;
	};
	bdn.onMouseUp = function() {
		this.src = js_NumericDownUp;
		if (json.Value > json.Min || json.Loop) {
			json.Value = Math.round((json.Value - json.Interval) * Math.pow(10, 3)) / Math.pow(10, 3);
			if (json.Value < json.Min) {
				if (json.Loop)
					json.Value = json.Max;
				else
					json.Value = json.Min;
			}
		}
		json.Object.TextArea.data = json.Value;
	};
	frame.addSubview(bdn);

	var txt = new Text();
	if (json.Tooltip != null) 
		txt.tooltip = json.Tooltip;
	if (json.Font != null)
		txt.font = json.Font;
	if (json.Size != null)
		txt.size = json.Size;
	if (json.Style != null)
		txt.style = json.Style;
	if (json.Color != null)
		txt.color = json.Color;
	if (json.ShadowColor != null && json.ShadowColor != '')
		txt.shadow = getShadow(json.ShadowColor);
	txt.data = json.Value;
	txt.hAlign = 'center';
	txt.setPosition(json.Left + (json.Width - (json.Height - 4)) / 2, json.Top + txt.height);
	frame.addSubview(txt);

	json.Object = { Box:box, UpButton:bup, DownButton:bdn, TextArea:txt };
	return json;
}
