function switchTab(idx) {
	if (tabPageNow != null)
		tabPageNow.removeFromSuperview();
	tabPageNow = new Image();
	tabPageNow.src = 'Resources/Images/Tabs/Tab' + (idx + 1) + '.png';
	tabPageNow.setPosition(15, 0);
	tabPageNow.zOrder = 15;
	frmBase.addSubview(tabPageNow);
	for (var i = 0; i < tabContent.length; i++)
		tabContent[i].visible = false;
	tabContent[idx].visible = true;
	imgShowArea.src = 'Resources/Images/ShowBack' + (idx + 1) + '.png';
	imgShowArea.visible = true;
}

function disableTabEvents() {
	for (var i = 0; i < tabImages.length; i++) {
		tabImages[i].onMouseEnter = null;
		tabImages[i].onMouseExit = null;
		tabImages[i].onMouseDown = null;
		tabImages[i].onMouseUp = null;
	}
}

function enableTabEvents() {
	for (var i = 0; i < tabImages.length; i++) {
		tabImages[i].onMouseEnter = 'tab_onMouseEnter(' + i + ');';
		tabImages[i].onMouseExit = 'tab_onMouseExit(' + i + ');';
		tabImages[i].onMouseDown = 'tab_onMouseDown(' + i + ');';
		tabImages[i].onMouseUp = 'tab_onMouseUp(' + i + ');';
	}
}

function resetBloodRadio() {
	js_BloodRadio.SelectedIndex = -1;
	js_BloodRadio.SelectedValue = '';
	for (var i = 0; i < js_BloodRadio.Items.length; i++)
		js_BloodRadio.Items[i].Object = null;

}

function getCellObject(grid, bgName) {
	for (var i = 0; i < grid.rows.length; i++) {
		var row = grid.rows[i];
		for (var j = 0; j < row.cells.length; j++) {
			if (bgName == row.cells[j].Object.Background.name)
				return { Row:row, Cell:row.cells[j], ColumnKey:row.cells[j].column.key };
		}
	}
	return null;
}

function periodItemModify(idx) {
	clearSelectedRow();
	var cell1 = gridPeriod.getCell(idx, 'Date');
	dccPeriod.Date = cell1.text;
	dccPeriod.Object.Label.data = dccPeriod.Date;
	var cell2 = gridPeriod.getCell(idx, 'Length');
	nudPeriod.Value = eval(cell2.text);
	nudPeriod.Object.TextArea.data = nudPeriod.Value;
	setSelectedRow(cell1.row);
}	

function temperItemModify(idx) {
	clearSelectedRow();
	var cell1 = gridTemper.getCell(idx, 'Date');
	dccTemper.Date = cell1.text;
	dccTemper.Object.Label.data = dccTemper.Date;
	var cell2 = gridTemper.getCell(idx, 'Temperature');
	nudTemper.Value = eval(cell2.text);
	nudTemper.Object.TextArea.data = nudTemper.Value;
	setSelectedRow(cell1.row);
}	

function setSelectedRow(row) {
	js_SelectedRow = row;
	for (var i = 0; i < row.cells.length; i++) {
		var cell = js_SelectedRow.cells[i];
		if (row.cells[i].Object.Background != null)
			cell.Object.Background.src = js_SelectedRowBackground_S;
		if (cell.Object.ForeText != null)
			cell.Object.ForeText.color = js_SelectedRowTextColor;
	}
	
}

function clearSelectedRow() {
	if (js_SelectedRow == null)
		return;
	for (var i = 0; i < js_SelectedRow.cells.length; i++) {
		var cell = js_SelectedRow.cells[i];
		if (cell.Object.Background != null) {
			if (cell.bgImageSrc != null)
				cell.Object.Background.src = cell.bgImageSrc;
			else
				cell.Object.Background.src = js_SelectedRow.grid.cellBgImageSrc;
		}
		if (cell.Object.ForeText != null) {
			if (cell.color != null)
				cell.Object.ForeText.color = cell.color;
			else if (js_SelectedRow.grid.columns[i].cellStyle.color != null)
				cell.Object.ForeText.color = js_SelectedRow.grid.columns[i].cellStyle.color;
			else
				cell.Object.ForeText.color = '';
		}
	}
	js_SelectedRow = null;
}

function deleteRecordItem(xmlDoc, grid, row) {
	var cell = row.getCellByColumnKey('Date');
	var root = xmlDoc.documentElement;
	var nodes = root.evaluate('Table[Date="' + cell.text + '"]');
	root.removeChild(nodes.item(0));
	grid.removeRow(row);
	rows = root.evaluate('Table');
	if (grid.name == 'gridPeriod')
		rows.item(0).evaluate('Cycle').item(0).firstChild.data = 'N/A';
	renderGrid(grid, xmlDoc, js_PeriodGridColumns, js_GridForm[0]);
}

function showMemoWindow() {
	if (winMemo == null || typeof(winMemo) == 'undefined' || !(winMemo instanceof Window)) {
		winMemo = new Window();
		winMemo.name = 'winMemo';
		winMemo.alignment = 'left';
		winMemo.width = 340;
		winMemo.height = 220;
		createWinContent(winMemo, jscl_ApplicationDescription);
	}
	winMemo.visible = true;
}

function showVerWindow() {
	if (winVer == null || typeof(winVer) == 'undefined' || !(winVer instanceof Window)) {
		winVer = new Window();
		winVer.name = 'winVer';
		winVer.alignment = 'left';
		winVer.width = 340;
		winVer.height = 220;
		createWinContent(winVer, jscl_VerHistory.join('\n'));
	}
	winVer.visible = true;

}

function createWinContent(win, memo) {
	var bg = new Image();
	with (bg) {
		window = win;
		src = 'Resources/Images/Memo.png';
		setPosition(0, 0);
		onMouseUp = function() { this.window.visible = false; };
	}
	var lab = new Text();
	with (lab) {
		data = jscl_ApplicationTitle;
		setPosition(win.width / 2, 28);
		hAlign = 'center';
		font = js_DisplayFont;
		size = 16;
		style = 'bold';
		color = '#FFFFFF';
		shadow = getShadow();
		window = win;
	}

	var txt = new TextArea();
	with (txt) {
		data = memo;
		setPositionAndSize(25, 40, 290, 155);
		font = js_DisplayFont;
		size = 12;
		color = '#FFFFFF';
		editable = false;
		window = win;
	}
}
