function getMCDate(mc) {
	if (typeof(mc) != 'Date')
		return new Date(mc);
	else
		return mc;
}

function getNextMCDate(mc, cycle) {
	var mcDate = getMCDate(mc);
	return mcDate.DateAdd('d', cycle);
}

function getPrevMCDate(mc, cycle) {
	var mcDate = getMCDate(mc);
	return mcDate.DateAdd('d', -cycle);
}

function getOvulateDate(mc, cycle) {
	var mcDate = getMCDate(mc);
	var nextOvul = mcDate.DateAdd('d', -15);
	var prevOvul = mcDate.DateAdd('d', cycle - 15);
	return {'PrevOvul':prevOvul, 'NextOvul':nextOvul };
}

function getMonthMCDate(mc, cycle, year, month) {
	var Dates = new Array();
	var mcDate = getMCDate(mc);
	var getMonth = new Date(year, month - 1, 1);
	var out = false;
	if (mcDate.DateDiff('m', getMonth) != 0) {
		if (mcDate.DateDiff('m', getMonth) > 0)
			var c = cycle;
		else
			var c = -cycle;
		while (mcDate.DateDiff('m', getMonth) > 0) {
			mcDate = mcDate.DateAdd('d', c);
			while (mcDate.DateDiff('m', getMonth) == 0) {
				Dates[Dates.length] = mcDate;
				mcDate = mcDate.DateAdd('d', c);
				out = true;
			}
			if (out)
				break;
		}
		if (!out && mcDate.DateDiff('m', getMonth) < 0) {
			Dates[0] = mcDate;
		}
	} else {
		Dates[0] = mcDate;
	}
	return Dates;
}

function sortXml(xmlDoc, rowTag, cellTag, desc) {
	var root = xmlDoc.documentElement;
	var rows = root.evaluate(rowTag + '/' + cellTag);
	var idxs = new Array(rows.length);
	for (var i = 0; i < idxs.length; i++) 
		idxs[i] = new Date(rows.item(i).firstChild.data).getTime();
	idxs.sort();
	var newRows = new Array(rows.length);
	if (yws_isUndefined(desc) || !desc) {
		for (var i = 0; i < idxs.length; i++) { 
			var d1 = new Date(idxs[i]);
			newRows[i] = root.evaluate(rowTag + '[' + cellTag + '="' + d1.toFormatString('ed', true) + '"]').item(0).toXML();
		}
	} else {
		for (var i = 0; i < idxs.length; i++) { 
			var d1 = new Date(idxs[idxs.length - i - 1]);
			newRows[i] = root.evaluate(rowTag + '[' + cellTag + '="' + d1.toFormatString('ed', true) + '"]').item(0).toXML();
		}
	}
	return XMLDOM.parse('<NewDataSet>' + newRows.join('') + '</NewDataSet>');
}

function recountPervPeriodRange(xmlDoc) {
	var root = xmlDoc.documentElement;
	var rows = root.evaluate('Table');
	for (var i = 0; i < rows.length; i++) {
		rows.item(i).evaluate('Cycle').item(0).firstChild.data = 'N/A';
	}
	for (var i = rows.length - 1; i > 0; i--) {
		var d1 = rows.item(i - 1).evaluate('Date').item(0).firstChild.data;
		var d2 = rows.item(i).evaluate('Date').item(0).firstChild.data
		var dd1 = new Date(d1);
		var dd2 = new Date(d2);
		rows.item(i).evaluate('Cycle').item(0).firstChild.data = dd2.DateDiff('d', dd1);
	}
}

function reckonAverageCycle(xmlDoc) {
	var root = xmlDoc.documentElement;
	var rows = root.evaluate('Table');
	var total = 0;
	var count = 0;
	for (var i = 0; i < rows.length; i++) {
		var v = rows.item(i).evaluate('Cycle').item(0).firstChild.data;
		if (v != 'N/A') {
			total += parseInt(v);
			count++;
		}
	}
	return Math.floor(total / count);
}

function getOvulateDays(xmlDoc, cycle) {
	var root = xmlDoc.documentElement;
	var rows = root.evaluate('Table/Date');
	var arr = new Array();
	for (var i = 0; i < rows.length; i++) {
		var d = rows.item(i).firstChild.data;
		arr[arr.length] = getOvulateDate(d, cycle);
	}
	return arr;
}

function getPervPeriodRange(xmlDoc, date) {
	var root = xmlDoc.documentElement;
	var rows = root.evaluate('Table/Date');
	var d1 = new Date(date);
	var ld = null;
	for (var i = 0; i < rows.length; i++) {
		var d2 = new Date(rows.item(i).firstChild.data);
		if (d1.DateDiff('d', d2) < 0) {
			ld = d2;
			continue;
		} else 
			break;
	}
	if (ld == null)
		return 'N/A';
	else
		return ld.DateDiff('d', d1);
}
function getPredictPeriodDate(xmlDoc, cycle) {
	var root = xmlDoc.documentElement;
	var rows = root.evaluate('Table/Date');
	if (rows.length == 0)
		return null;
	var d1 = new Date(rows.item(0).firstChild.data);
	for (var i = 1; i < rows.length; i++) {
		var d2 = new Date(rows.item(i).firstChild.data);
		if (d1.DateDiff('d', d2) > 0)
			d1 = d2;
	}
	return getNextMCDate(d1, cycle);
}

function checkIsFutureDay(date) {
	var today = new Date();
	var chk = new Date(date);
	return (today.DateDiff('d', chk) > 0);
}

function temperatureConvert(value, c2f) {
	if (c2f) {
		return Math.round((value * 1.8 + 32) * Math.pow(10, 5)) / Math.pow(10, 5);
	} else {
		return Math.round(((value - 32) / 1.8) * Math.pow(10, 5)) / Math.pow(10, 5);
	}
}
